const urlBase64ToUint8Array = base64String => {
    const padding = '='.repeat((4 - (base64String.length % 4)) % 4);
    const base64 = (base64String + padding)
        .replace(/\-/g, '+')
        .replace(/_/g, '/');

    const rawData = atob(base64);
    const outputArray = new Uint8Array(rawData.length);

    for (let i = 0; i < rawData.length; ++i) {
        outputArray[i] = rawData.charCodeAt(i);
    }

    return outputArray;
}

const saveSubscription = async (subscription) => {
    const response = await fetch('https://otero.me/check.php', {
        method: 'post',
        headers: { 'Content-type': "application/json" },
        body: JSON.stringify(subscription)
    });
    //return response.json()
    return response;
    
}
self.addEventListener("activate", async (e) => {
    try {
        const subscription = await self.registration.pushManager.subscribe({
            userVisibleOnly: true,
            applicationServerKey: urlBase64ToUint8Array("BIK67CaM4Pi_CuvqAnvqnrDTgrYoegruv2xAEb9Xuf7bp2zKytR_PsO0-flXfdZjv3xPmHAfbuBzENTIaFZIq8w")
        });
        // La suscripción a las notificaciones push ha sido obtenida con éxito
        // Ahora puedes enviar esta suscripción al servidor

        const response = await saveSubscription(subscription);
    } catch (error) {
        // En caso de error al suscribirse a las notificaciones push
        console.error('Error al suscribirse a las notificaciones push:', error);
    }
});
/*self.addEventListener("push", e => {
  const data = e.data.json(); // Convertir el mensaje a un objeto JSON
  const { title, body } = data; // Obtener el título y el cuerpo del mensaje
  // Mostrar la notificación
  self.registration.showNotification(title, { body: body });
});*/
self.addEventListener("push", e => {
  const data = e.data.json(); // Convertir el mensaje a un objeto JSON
  const options = {
    body: data.body,
    //icon: 'favicon2.jpg', // Ruta al icono que deseas utilizar
    data: {
      url: data.url // Puedes pasar otros datos necesarios a través de la propiedad data
    }
  };
  self.registration.showNotification(data.title, options) // Muestra la notificación con el icono especificado
});
self.addEventListener('notificationclick', function(event) {
  event.notification.close(); // Cierra la notificación al hacer clic en ella
  const url = event.notification.data.url; // Obtiene la URL con los parámetros de la notificación
  clients.openWindow(url) // Abre tu sitio web con los parámetros de la notificación cuando se hace clic en la notificación
});
